<script lang="ts">
import Vue from 'vue';
import { kebabCase } from 'lodash';

import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../../../common/meta';
import CropInfinityHero from '../../../components/common/crop-infinity-hero.vue';

import TopNavigation from '../../../components/common/top-navigation.vue';
import TechnologyPartnerPlatformSection from '../../../components/partners/technology-partners/platform-section.vue';
import SlpTypeahead from '../../../components/common/typeahead.vue';

import { CONTENT_TYPES } from '../../../common/content-types';
import { techPartnerService } from '../../../services/partners/technology-partners.service';
import TechnologyPartnersNextStep from '@/components/partners/technology-partners/next-step.vue';
import { getClient } from '~/plugins/contentful.js';

const getSectionIcon = (sectionName: string, groupButtons: Array<any>) => {
  const sectionIcon = groupButtons
    .map((button) => {
      const editedButton = { ...button };
      editedButton.sectionName = button.href.replace('#', '');
      return editedButton;
    })
    .find((button) => button.sectionName === sectionName);

  return sectionIcon ? sectionIcon.icon_left : null;
};

export default Vue.extend({
  components: {
    TechnologyPartnerPlatformSection,
    TopNavigation,
    SlpTypeahead,
    CropInfinityHero,
    TechnologyPartnersNextStep,
  },
  nuxtI18n: false,
  async asyncData({ error }: any) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'partners/technology-partners',
        include: 10,
      });

      const { schema, pageContent } = response.items[0].fields;
      const seoMetadata = response.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };

      const partners = techPartnerService(pageContent, schema);

      const suggestions = [];
      const typeaheadSections = [];

      // eslint-disable-next-line no-restricted-syntax
      for (const platform of partners.all_partners.categories) {
        const sectionName = platform.id;
        const suggestion = { name: sectionName, data: [] };

        // eslint-disable-next-line no-restricted-syntax
        for (const application of platform.partners) {
          suggestion.data.push({
            name: application.title,
            value: application.id || kebabCase(application.title),
          });
        }

        typeaheadSections.push({
          sectionName,
          iconName: getSectionIcon(
            kebabCase(sectionName),
            partners.navigation.buttons,
          ),
        });

        suggestions.push(suggestion);
      }

      return { partners, metadata, suggestions, typeaheadSections };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
  methods: {
    onSelectPartner(partner: { name: string; value: string }) {
      this.$router.push(`#${partner.value}`);
    },
  },
});
</script>

<template>
  <div>
    <CropInfinityHero :data="partners.hero" />
    <SlpContainer>
      <SlpTypeahead
        data-aos="zoom-in-up"
        data-aos-duration="800"
        :options="suggestions"
        :placeholder="partners.search.placeholder"
        :sections="typeaheadSections"
        @select="onSelectPartner"
      />
      <TopNavigation
        class="find-partners__navigation"
        :data="partners.navigation"
        :sensitivity="0.05"
        :skip="1"
      >
        <template #before>
          <TechnologyPartnerPlatformSection
            :platform="partners.featured_partners"
          />
        </template>
        <div
          v-for="platform in partners.all_partners.categories"
          :id="platform.id"
          :key="platform.title"
        >
          <TechnologyPartnerPlatformSection :platform="platform" />
        </div>
      </TopNavigation>
    </SlpContainer>
    <SlpContainer variant="gradient">
      <TechnologyPartnersNextStep :data="partners.next_step" :sensitivity="0" />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.find-partners {
  &__navigation {
    &:deep .group-cta {
      margin-top: 0 !important;
      margin-bottom: $spacing-96 !important;
    }
  }
}
</style>
